Receivd.downloader = {
	downloadFromXMPP: function(stanza) {
		var url = $(stanza).find("desktop_dl_url").text();
		var fileId = $(stanza).find("id").text();
		var fileName = $(stanza).find("truncated_file_name").text();
		var senderId = $(stanza).find("sender_id").text();
		var senderName = $(stanza).find("sender_name").text();

		var directoryToSaveIn = senderId + " - " + senderName;
		directoryToSaveIn = Receivd.saveDirectory.resolvePath(directoryToSaveIn);
		directoryToSaveIn.createDirectory();
		log("SAVING TO: "+directoryToSaveIn.nativePath);
		log(url); log(fileName);

		var gen_id = Math.floor(Math.random()*1001);
		$("div#activity").prepend("<div id='"+gen_id+"' class='download pending'><div class='file_name'>"+fileName+"</div><div class='from'>from <b>"+senderName+"</b></div> <div class='meta'><span class='percent'>0</span>% <span class='notice'>pending</span></div><div class='clearfix'></div></div>");
		Receivd.clearButton.show();

		Receivd.downloadQueue.push(function(afterDone) {
			var urlStream = new air.URLStream();
			var request = new air.URLRequest(url);
    	var file = directoryToSaveIn.resolvePath(fileName);
			var fileStream = new air.FileStream();
    	fileStream.openAsync(file, air.FileMode.WRITE);

    	urlStream.addEventListener(air.Event.COMPLETE, function(e) {
				// finish off the last block
				var dataBuffer = new air.ByteArray();
				urlStream.readBytes(dataBuffer, 0, urlStream.bytesAvailable);
				fileStream.writeBytes(dataBuffer, 0, dataBuffer.length);			
				$("div#activity").find("div#"+gen_id).addClass("completed")
				$("div#activity").find("div#"+gen_id+" span.percent").html("100");
				$("div#activity").find("div#"+gen_id+" span.notice").html("complete");

				log("DONE WRITING!: "+fileName+ " from "+url);
				fileStream.close();
				urlStream.close();

				$("div#activity").find("div#"+gen_id).dblclick(function() { file.openWithDefaultApplication(); });

				// save lastFileId
				var _lastFileIdArray = new air.ByteArray();
				_lastFileIdArray.writeUTFBytes(fileId);
				air.EncryptedLocalStore.setItem("lastFileId", _lastFileIdArray);
				air.trace("SAVING LAST FILE ID: "+fileId);

				displayNotification("Received "+fileName+"<br/><span class='sender'>from "+senderName+"</span>");

				if(afterDone) afterDone(); // run callbacks from the queue
			});

    	urlStream.addEventListener(air.ProgressEvent.PROGRESS, function(e) {
				if (urlStream.bytesAvailable > 50*1024) {
					var percentCompleted = (e.bytesLoaded/e.bytesTotal)*100;
					//air.trace("PROGRESS DL: "+percentCompleted);
					$("div#activity").find("div#"+gen_id).addClass("active")
					$("div#activity").find("div#"+gen_id+" span.percent").html(Math.floor(percentCompleted));
					$("div#activity").find("div#"+gen_id+" span.notice").html("");
					var dataBuffer = new air.ByteArray();
					urlStream.readBytes(dataBuffer, 0, urlStream.bytesAvailable);
					fileStream.writeBytes(dataBuffer, 0, dataBuffer.length);
				}
			});

    	urlStream.addEventListener(air.IOErrorEvent.IO_ERROR, function(e) {
				air.trace("CRASH");
				$("div#activity").find("div#"+gen_id).addClass('failed');				
			});

    	urlStream.load(request);
		});
	}
};

var ReceivdQueue = Backbone.Model.extend({
	initialize: function() {
		_.bindAll(this, "push", "pop", "loop", 'onQuiet');
		this.operations = [];
		this.loop();
	},

	loop: function() {
		var op = this.operations.shift();	
		if(op) { 
			op(this.loop); //call the operation with a afterDone callback
		} else {
			this.onQuiet();
			//air.trace(this.id + " SLEEP");
			setTimeout(this.loop, 1000);
		}
	},

	onQuiet: function() { //replace this with something based on the queue
	},

	push: function(op) { this.operations.push(op); },
	pop: function() { this.operations.pop(); }
});


Receivd.realtime = {
  connectToServer: function(jid, password) {
    connection.rawInput = rawInput;
    connection.rawOutput = rawOutput;

    connection.connect(jid+"/windows_air_"+Math.floor(Math.random()*10001), password, this.onConnect);

    return true;
  },


  onConnect: function(status) {
    if (status == Strophe.Status.CONNECTING) {
     log('Strophe is connecting.');
    } else if (status == Strophe.Status.CONNFAIL) {
     log('Strophe failed to connect.');
      $('#connect').get(0).value = 'connect';
    } else if (status == Strophe.Status.DISCONNECTING) {
     log('Strophe is disconnecting.');
    } else if (status == Strophe.Status.DISCONNECTED) {
     log('Strophe is disconnected.');
      $('#connect').get(0).value = 'connect';
    } else if (status == Strophe.Status.CONNECTED) {
     	log('Strophe is connected.');
    	Receivd.realtime.sendPresence();
    	Receivd.realtime.attachHandlers();
    }
  },

  sendPresence: function() {
		log("SENDING PRESENCE!!!!!!!!!");
    var pres = $pres().c("c", {xmlns:  "http://jabber.org/protocol/caps",
                  node:  "http://psi-im.org/caps", ver: "0.12",
                  ext:   "cs ep-notify html"}).up().
               c("priority").t("5");
                    
    connection.send(pres.tree());
    return true;
  },
  

  attachHandlers: function() {
    connection.addHandler(this.onConnectionRequestMessage, 
        null, 'message', 'connection_request', null, null); 
    connection.addHandler(this.onConnectionConfirmedMessage,
        null, 'message', 'confirmed', null, null);
    connection.addHandler(this.onConnectionDeletedMessage,
        null, 'message', 'deleted', null, null);
    connection.addHandler(this.onPubsubMessage, 
        'http://jabber.org/protocol/pubsub#event', 'message', null, null, null);
  },

  onConnectionConfirmedMessage: function(stanza) {
    //console.log("CONN CONFIRMED");
    Receivd.sidebar.connections.fetch();
    return true;
  },

  onConnectionDeletedMessage: function(stanza) {
    //console.log("CONN DELETED");
    Receivd.sidebar.connections.fetch(); 
    return true;
  },

  onConnectionRequestMessage: function(stanza) {
    //console.log("CONN REQUEST");
    Receivd.sidebar.bumpConnectionRequestCount();
    return true;
  },

  onPubsubMessage: function(stanza) {
    // filter out node presence messages that are received at the beginning
    var item = $(stanza).find("items:first")
    if(item.text() == "") { return true; }

		Receivd.downloader.downloadFromXMPP(item);
    // insert file into the app
    //Receivd.browserView.insertFileFromXMPP(item, true);
    return true;
  }
};
